Index: lib/spatial/mapbuilder/examples/catalog/wrs_Query.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/wrs_Query.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/wrs_Query.xsl	(revision 4307)
@@ -0,0 +1,202 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<!--
+Description: Generates a EBRIM Catalog Query from Filter Paramaters provided
+Author:      rdewit
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id:$
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:wms="http://www.opengis.net/wms"
+    xmlns:ogc="http://www.opengis.net/ogc"
+    xmlns:ows="http://www.opengis.net/ows"
+    xmlns:csw="http://www.opengis.net/cat/csw"
+    xmlns:gml="http://www.opengis.net/gml"
+    xmlns:rim="urn:oasis:names:tc:ebxml-regrep:rim:xsd:2.5"
+    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xmlns:wfs="http://www.opengis.net/wfs" 
+    xmlns:sld="http://www.opengis.net/sld"
+    xmlns:owscat="http://www.ec.gc.ca/owscat"
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:xlink="http://www.w3.org/1999/xlink">
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+  <xsl:strip-space elements="*"/>
+
+
+  <!-- Match Root -->
+  <xsl:template match="/">
+
+  <GetRecords 
+    xmlns:csw="http://www.opengis.net/csw" 
+    xmlns:ogc="http://www.opengis.net/ogc" 
+    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
+    xmlns:gml="http://www.opengis.net/gml" 
+    csw:schemaLocation="http://www.opengis.net/csw http://schemas.cubewerx.com/csw/2.0.0/CSW-discovery.xsd" 
+    ogc:schemaLocation="http://www.opengis.net/ogc http://schemas.cubewerx.com/schemas/filter/1.0.0/filter.xsd" 
+    service="WRS" 
+    version="2.0.0" 
+    outputFormat="text/xml" 
+    startPosition="1" 
+    maxRecords="1000" 
+    resultType="RESULTS">
+
+    <Query typeNames="ExtrinsicObject Association=ServiceAssociation Service">
+      <ElementName>/ExtrinsicObject</ElementName>
+      <ElementName>/Service</ElementName>
+
+      <!-- Check if there is a (non-empty) filter node -->
+      <!-- If so, loop through children and look for templates that match them -->
+      <xsl:if test="filter/*">
+      <Constraint>
+        <ogc:Filter>
+          <ogc:And>
+          <xsl:for-each select="filter/*">
+            <xsl:if test="node()">
+            <xsl:apply-templates select="."/>
+            </xsl:if>
+          </xsl:for-each>
+          </ogc:And>
+        </ogc:Filter>
+      </Constraint>
+      </xsl:if>
+
+    </Query>
+  </GetRecords>
+
+  </xsl:template>
+
+
+  <xsl:template match="serviceassociation">
+    <!-- Link the layer (coming from the extrinsic object), to the service object via the "Serves" association -->
+    <!-- Can be things like: OperatesOn, Serves, etc -->
+    <ogc:And>
+      <ogc:PropertyIsEqualTo>
+        <ogc:PropertyName>/ExtrinsicObject/@ID</ogc:PropertyName>
+        <ogc:PropertyName>/ServiceAssociation/@targetObject</ogc:PropertyName>
+      </ogc:PropertyIsEqualTo>
+      <ogc:PropertyIsLike>
+        <ogc:PropertyName>/ServiceAssociation/@associationType</ogc:PropertyName>
+        <ogc:Literal><xsl:value-of select="."/></ogc:Literal>
+      </ogc:PropertyIsLike>
+      <ogc:PropertyIsEqualTo>
+        <ogc:PropertyName>/Service/@ID</ogc:PropertyName>
+        <ogc:PropertyName>/ServiceAssociation/@sourceObject</ogc:PropertyName>
+      </ogc:PropertyIsEqualTo>
+    </ogc:And>
+  </xsl:template>
+
+  <xsl:template match="featuretype">
+		<!-- The object type has to be either a feature type WFS_layer or WMS_Layer -->
+    <ogc:Or>
+      <ogc:PropertyIsLike>
+        <ogc:PropertyName>/ExtrinsicObject/@objectType</ogc:PropertyName>
+        <ogc:Literal>FeatureType</ogc:Literal>
+      </ogc:PropertyIsLike>
+      <ogc:PropertyIsLike>
+        <ogc:PropertyName>/ExtrinsicObject/@objectType</ogc:PropertyName>
+        <ogc:Literal><xsl:value-of select="."/></ogc:Literal>
+      </ogc:PropertyIsLike>
+    </ogc:Or>
+  </xsl:template>
+
+  <xsl:template match="servicetype">
+    <!-- Can be things like: WFS, WMS, etc -->
+    <ogc:And>
+      <ogc:PropertyIsEqualTo>
+        <ogc:PropertyName>/Service/Slot/@name</ogc:PropertyName>
+        <ogc:Literal>Service Type</ogc:Literal>
+      </ogc:PropertyIsEqualTo>
+      <ogc:PropertyIsEqualTo>
+        <ogc:PropertyName>/Service/Slot/ValueList/Value</ogc:PropertyName>
+        <ogc:Literal><xsl:value-of select="."/></ogc:Literal>
+      </ogc:PropertyIsEqualTo>
+    </ogc:And>
+  </xsl:template>
+
+  <xsl:template match="keywords">
+    <xsl:call-template name="tokenize">
+      <xsl:with-param name="inputString" select="concat(normalize-space(.),' ')"/>
+      <xsl:with-param name="resultElement" select="'keyword'"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template name="keyword">
+    <xsl:param name="keyword"/>
+      <ogc:Or>
+        <ogc:PropertyIsLike>
+          <ogc:PropertyName>/ExtrinsicObject/Name/LocalizedString/@value</ogc:PropertyName>
+          <ogc:Literal>%<xsl:value-of select="$keyword"/>%</ogc:Literal>
+        </ogc:PropertyIsLike>
+        <ogc:PropertyIsLike>
+          <ogc:PropertyName>/ExtrinsicObject/Description/LocalizedString/@value</ogc:PropertyName>
+          <ogc:Literal>%<xsl:value-of select="$keyword"/>%</ogc:Literal>
+        </ogc:PropertyIsLike>
+        <ogc:And>
+          <ogc:PropertyIsEqualTo>
+            <ogc:PropertyName>/ExtrinsicObject/Slot/@name</ogc:PropertyName>
+            <ogc:Literal>Keyword</ogc:Literal>
+          </ogc:PropertyIsEqualTo>
+          <ogc:PropertyIsLike>
+            <ogc:PropertyName>/ExtrinsicObject/Slot/ValueList/Value</ogc:PropertyName>
+            <ogc:Literal>%<xsl:value-of select="$keyword"/>%</ogc:Literal>
+          </ogc:PropertyIsLike>
+        </ogc:And>
+      </ogc:Or>
+  </xsl:template>
+
+  <!-- TODO: make this generic -->
+  <xsl:template match="location">
+    <ogc:BBOX>
+      <ogc:PropertyName>/ExtrinsicObject/Slot[@name='FootPrint']/ValueList/Value[1]</ogc:PropertyName>
+      <gml:Box srsName="EPSG:4326">
+        <gml:coordinates><xsl:value-of select="."/></gml:coordinates>
+      </gml:Box>
+    </ogc:BBOX>
+  </xsl:template>
+
+
+  <!-- Code to tokenize a string into nodes --> 
+  <!-- This can be used to convert a string with keywords to an XML representation -->
+  <!-- It fails with the last word if there is no whitespace after that word :-S -->
+  <!-- http://www.biglist.com/lists/xsl-list/archives/200603/msg00083.html -->
+  <xsl:template name="tokenize">
+    <xsl:param name="inputString"/>
+    <xsl:param name="separator" select="' '"/>
+    <xsl:param name="resultElement" select="'item'"/>
+    <xsl:variable
+      name="token"
+      select="substring-before($inputString, $separator)"
+    />
+    <xsl:variable
+      name="nextToken"
+      select="substring-after($inputString, $separator)"
+    />
+
+    <xsl:if test="$token">
+      <xsl:call-template name="keyword">
+        <xsl:with-param name="keyword" select="$token"/>
+      </xsl:call-template>
+    </xsl:if>
+
+    <xsl:if test="$nextToken">
+      <xsl:call-template name="tokenize">
+        <xsl:with-param
+          name="inputString"
+          select="$nextToken"/>
+        <xsl:with-param
+          name="separator"
+          select="$separator"/>
+        <xsl:with-param
+          name="resultElement"
+          select="$resultElement"/>
+      </xsl:call-template>
+    </xsl:if>
+  </xsl:template>
+
+  <xsl:template match="text()|@*"/>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/catalog/Save.js
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/Save.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/Save.js	(revision 4307)
@@ -0,0 +1,70 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: Save.js 3052 2007-08-01 21:25:21Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+
+/**
+ * When this button is pressed the targetModel is posted to the serializeUrl.
+ * Also defines a listener function for the "modelSaved" event which opens 
+ * the serialized document in a new browser window but only
+ * if the a popupWindowName property is defined for the button in config.
+ *
+ * @constructor
+ * @base ButtonBase
+ * @param widgetNode  The widget node from the Config XML file.
+ * @param model  The model for this widget
+ */
+function Save(widgetNode, model) {
+  ButtonBase.apply(this, new Array(widgetNode, model));
+
+  /**
+   * Add event listener to the modelSaved event
+   * @param objRef Pointer to this widget
+   */
+  this.init = function(objRef) {
+    objRef.targetModel.addListener("modelSaved", objRef.popupContext, objRef);
+  }
+  this.model.addListener("loadModel", this.init, this );
+
+ /**
+   * Save model control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} instance of the OL control.
+   */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+    
+      type: OpenLayers.Control.TYPE_BUTTON,
+      
+      trigger: function () {
+        objRef.targetModel.saveModel(objRef.targetModel);
+       },
+       CLASS_NAME: 'mbControl.Save'
+  });
+  return Control;
+  }
+
+ /**
+   * Open popup window with context
+   * @param objRef reference to this object.
+   * @return none 
+   */
+  this.popupContext = function(objRef) {
+    url = objRef.targetModel.getParam("modelSaved");
+    if (url) {
+      var popup=window.open(url);
+      if (!popup) {
+        alert('Please allow popups in order to save the context');
+      }
+    } else {
+      alert('Model could not be saved. Our apologies.');
+    }
+  }
+
+
+}
+
+
Index: lib/spatial/mapbuilder/examples/shipTracks/data/features.sld
===================================================================
--- lib/spatial/mapbuilder/examples/shipTracks/data/features.sld	(nonexistent)
+++ lib/spatial/mapbuilder/examples/shipTracks/data/features.sld	(revision 4307)
@@ -0,0 +1,88 @@
+<?xml version="1.0" encoding="utf-8" standalone="no" ?>
+<StyledLayerDescriptor version="1.0.0"
+  xsi:schemaLocation="http://www.opengis.net/sld StyledLayerDescriptor.xsd"
+  xmlns="http://www.opengis.net/sld"
+  xmlns:ogc="http://www.opengis.net/ogc"
+  xmlns:xlink="http://www.w3.org/1999/xlink"
+  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+  <!--
+    $Id: features.sld 3956 2008-03-31 13:28:30Z ahocevar $
+  -->
+  <NamedLayer>
+    <Name>testGmlRenderer</Name>
+    <UserStyle>
+      <Name>default</Name>
+      <IsDefault>true</IsDefault>
+      <FeatureTypeStyle>
+        <Rule>
+          <PointSymbolizer>
+            <Graphic>
+              <ExternalGraphic>
+                <OnlineResource xlink:href="images/frog.gif" />
+                <Format>image/gif</Format>
+              </ExternalGraphic>
+              <Mark />
+              <Opacity>0.8</Opacity>
+              <Size>10</Size>
+              <Rotation>45</Rotation>
+            </Graphic>
+          </PointSymbolizer>
+          <LineSymbolizer>
+            <Stroke>
+              <CssParameter name="stroke">#FF0000</CssParameter>
+              <CssParameter name="stroke-opacity">1</CssParameter>
+              <CssParameter name="stroke-width">3</CssParameter>
+            </Stroke>
+          </LineSymbolizer>
+          <PolygonSymbolizer>
+            <Fill>
+              <CssParameter name="fill">blue</CssParameter>
+              <CssParameter name="fill-opacity">0.6</CssParameter>
+            </Fill>
+            <Stroke>
+              <CssParameter name="stroke">blue</CssParameter>
+              <CssParameter name="stroke-opacity">1</CssParameter>
+              <CssParameter name="stroke-width">1</CssParameter>
+            </Stroke>
+          </PolygonSymbolizer>
+        </Rule>
+      </FeatureTypeStyle>
+    </UserStyle>
+    <UserStyle>
+      <Name>selected</Name>
+      <FeatureTypeStyle>
+        <Rule>
+          <PointSymbolizer>
+            <Graphic>
+              <ExternalGraphic>
+                <OnlineResource xlink:href="images/frog.gif" />
+                <Format>image/gif</Format>
+              </ExternalGraphic>
+              <Opacity>1.0</Opacity>
+              <Size>10</Size>
+              <Rotation>0</Rotation>
+            </Graphic>
+          </PointSymbolizer>
+          <LineSymbolizer>
+            <Stroke>
+              <CssParameter name="stroke">yellow</CssParameter>
+              <CssParameter name="stroke-opacity">1</CssParameter>
+              <CssParameter name="stroke-width">3</CssParameter>
+            </Stroke>
+          </LineSymbolizer>
+          <PolygonSymbolizer>
+            <Fill>
+              <CssParameter name="fill">#FFFF00</CssParameter>
+              <CssParameter name="fill-opacity">0.9</CssParameter>
+            </Fill>
+            <Stroke>
+              <CssParameter name="stroke">#FF0066</CssParameter>
+              <CssParameter name="stroke-opacity">1</CssParameter>
+              <CssParameter name="stroke-width">2</CssParameter>
+            </Stroke>
+          </PolygonSymbolizer>
+        </Rule>
+      </FeatureTypeStyle>
+    </UserStyle>
+  </NamedLayer>
+</StyledLayerDescriptor>
Index: lib/spatial/mapbuilder/examples/catalog/LayerControl.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/LayerControl.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/LayerControl.xsl	(revision 4307)
@@ -0,0 +1,350 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<xsl:stylesheet 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:gml='http://www.opengis.net/gml' 
+    xmlns:wfs='http://www.opengis.net/wfs'
+    xmlns:xlink='http://www.w3.org/1999/xlink'
+    version="1.0">
+    
+    
+
+    
+    
+<!--
+Description: provides a list of layers and controls for them (delete/visibility/move up/move down/show metadata
+Author:      Mike Adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html 
+
+$Id: LayerControl.xsl 2677 2007-04-06 08:37:01Z oterral $
+$Name:  $
+-->
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+  
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang"/>
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="skinDir"/>
+  <xsl:param name="opacity"/>
+
+  <!-- Text params for this widget -->
+  <xsl:param name="zoomImage"/>
+  <xsl:param name="layerIndexTip"/>
+  <xsl:param name="toggleVisTip"/>
+  <xsl:param name="moveLayerUpTip"/>
+  <xsl:param name="moveLayerDownTip"/>
+  <xsl:param name="deleteLayerTip"/>
+  <xsl:param name="legendTip"/>
+  <xsl:param name="nameLayerTip"/>
+  <xsl:param name="opacityTip"/>
+  <xsl:param name="title"/>
+  <xsl:param name="layerMetadata"/>
+  <xsl:param name="moveUpImage">/images/LayerMoveUpDisable.png</xsl:param>
+  <xsl:param name="moveDownImage">/images/LayerMoveDownDisable.png</xsl:param>
+  <xsl:param name="deleteImage">/images/LayerRemoveDisable.png</xsl:param>
+  <xsl:param name="legendImageEnable">/images/LegendEnable.png</xsl:param>
+  <xsl:param name="legendImageDisable">/images/LegendDisable.png</xsl:param>
+  <xsl:param name="layerAddImage">/images/LayerAddDisable.png</xsl:param>
+  <xsl:param name="layerMetadataImageDisable">/images/QueryDisable.png</xsl:param>
+  <xsl:param name="layerMetadataImageEnable">/images/QueryEnable.png</xsl:param>
+  <xsl:param name="loadingImage">/images/LoadingSpinner.gif</xsl:param>
+
+  <!-- 'mode' determines the mode of the layer control. Can be one of the following:
+         * default:     standard layer control
+         * layerselect: select layer to copy/move to other context
+  -->
+  <xsl:param name="mode">default</xsl:param>
+
+<!-- The name of the javascript context object to call -->
+  <xsl:param name="featureName"/>
+  <xsl:param name="hidden"/>
+  <xsl:param name="context">config.objects.<xsl:value-of select="$modelId"/></xsl:param>
+  <xsl:variable name="numLayers" select="count(//wmc:Layer | //wmc:FeatureType)"/>
+  
+<!-- Main html -->
+  <xsl:template match="/wmc:ViewContext">
+    <div>
+      <div class="layerControl">
+        <xsl:if test="wmc:General/wmc:Extension"> 
+		      <xsl:apply-templates select="wmc:General/wmc:Extension/wmc:GroupList/wmc:Group">
+				<xsl:sort select="position()" order="ascending" data-type="number"/>
+			  </xsl:apply-templates>
+		</xsl:if>
+        <xsl:if test="not(wmc:General/wmc:Extension)"> 					 
+			  <xsl:apply-templates select="wmc:LayerList/wmc:Layer">
+					  <xsl:sort select="position()" order="descending" data-type="number"/>
+			  </xsl:apply-templates>
+		</xsl:if> 
+      </div>
+    </div>
+  </xsl:template>
+  
+  <!-- Main html -->
+  <xsl:template match="/wmc:OWSContext">
+      <div class="layerControl">
+        <xsl:if test="$title">
+          <h3><xsl:value-of select="$title"/></h3>
+        </xsl:if>
+         <xsl:if test="wmc:General/wmc:Extension"> 
+            <xsl:apply-templates select="wmc:General/wmc:Extension/wmc:GroupList/wmc:Group">
+          <xsl:sort select="position()" order="ascending" data-type="number"/>
+          </xsl:apply-templates>
+         </xsl:if>
+         <xsl:if test="not(wmc:General/wmc:Extension)"> 
+          <xsl:apply-templates select="wmc:ResourceList/wmc:Layer | wmc:ResourceList/wmc:FeatureType">
+          <xsl:sort select="position()" order="descending" data-type="number"/>
+          </xsl:apply-templates>
+          </xsl:if> 	
+      </div>
+  </xsl:template>
+  
+  <!---->
+  
+
+  
+ <xsl:template match="wmc:General/wmc:Extension/wmc:GroupList/wmc:Group">
+		<xsl:variable name="GroupName" select="./@name"/>
+		<xsl:variable name="GroupFold" select="./@folded"/>
+		<xsl:variable name="numberOfLayerByGroup" select="count(//wmc:Layer[wmc:Extension/wmc:Group/@name=$GroupName] | //wmc:FeatureType[wmc:Extension/wmc:Group/@name=$GroupName])"/>
+		<xsl:variable name="numberOfLayerByGroupOther" >
+            <xsl:value-of select="  $numLayers - $numberOfLayerByGroup "/>
+        </xsl:variable>
+		<xsl:if test=" ( $numberOfLayerByGroup != 0) or ( ($numberOfLayerByGroupOther != 0 ) and ( $GroupName = 'Other') ) "> 
+			<div id="{$GroupName}_Header" style="cursor:pointer" class="GroupHeader" title="click to (un)fold" onmouseover="style.background='pink';" onMouseOut="style.background='#556655';"
+			onclick="config.objects.{$widgetId}.switchVisibilityById('{$GroupName}');config.objects.{$widgetId}.foldUnfoldGroup('{$GroupName}','{$GroupName}_fold');">
+				<!-- display "+" or "-" -->
+				<input type="button" class="GroupHeaderFold" id="{$GroupName}_fold" style="width:35px;">
+				<xsl:attribute name="value">
+				<xsl:choose>
+						<xsl:when test="@folded=1">+ </xsl:when>
+						<xsl:otherwise>-</xsl:otherwise>
+					</xsl:choose> 
+				</xsl:attribute>
+				</input>
+				
+				<div id="{$GroupName}_Title" class="GroupHeaderTitle">
+					<xsl:value-of select="$GroupName"/>
+				</div>
+			</div><!-- end of div GroupHeader -->
+			
+			<div id="{$GroupName}" class="GroupLayers" >
+			    <xsl:attribute name="style">
+					<xsl:choose>
+						<xsl:when test="@folded=1">display:none </xsl:when>
+						<xsl:otherwise>display:block</xsl:otherwise>
+					</xsl:choose> 
+				</xsl:attribute>
+				<xsl:if test="//wmc:ResourceList"> 
+					<xsl:apply-templates select="//wmc:ResourceList/wmc:Layer[wmc:Extension/wmc:Group/@name=$GroupName] | //wmc:ResourceList/wmc:FeatureType[wmc:Extension/wmc:Group/@name=$GroupName]" >
+						<xsl:sort select="position()" order="descending" data-type="number"/>
+					</xsl:apply-templates>
+				</xsl:if>	
+				<xsl:if test="//wmc:LayerList"> 
+					<xsl:apply-templates select="//wmc:LayerList/wmc:Layer[wmc:Extension/wmc:Group/@name=$GroupName]">
+						<xsl:sort select="position()" order="descending" data-type="number"/>
+					</xsl:apply-templates>
+				</xsl:if>
+                <xsl:if test="$GroupName='Other' ">
+					<xsl:if test="//wmc:ResourceList"> 
+					    <xsl:apply-templates select="//wmc:ResourceList/wmc:Layer[not(wmc:Extension/wmc:Group)] | //wmc:ResourceList/wmc:FeatureType[not(wmc:Extension/wmc:Group)]" >
+                            <xsl:sort select="position()" order="descending" data-type="number"/>
+					    </xsl:apply-templates>
+                    </xsl:if>	
+                    <xsl:if test="//wmc:LayerList"> 
+					    <xsl:apply-templates select="//wmc:LayerList/wmc:Layer[not(wmc:Extension/wmc:Group)]">
+                            <xsl:sort select="position()" order="descending" data-type="number"/>
+					    </xsl:apply-templates>
+				    </xsl:if>	
+				</xsl:if>
+			</div><!-- end of div {$GroupName} -->
+		</xsl:if>	
+</xsl:template>
+	
+	
+	
+	
+	
+<xsl:template match="wmc:Layer|wmc:FeatureType">
+	<xsl:variable name="GroupName" select="wmc:Extension/wmc:Group/@name"/>
+	<xsl:variable name="layerName" select="wmc:Name"/>
+	<xsl:variable name="LayerTitle" select="wmc:Title"/>
+	<xsl:variable name="layerTitle">
+	    <xsl:choose>
+		    <xsl:when test="wmc:Title/@xml:lang">
+			    <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
+			</xsl:when>
+			<xsl:otherwise>
+				<xsl:value-of select="wmc:Title"/>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:variable>
+
+  <!-- Use unique layer id. Fallback to layer name if non-existent -->
+	<xsl:variable name="layerId">
+    <xsl:choose>
+      <xsl:when test="@id">
+        <xsl:value-of select="@id"/>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:value-of select="$layerName"/>
+      </xsl:otherwise>
+    </xsl:choose>
+	</xsl:variable>
+
+  <xsl:variable name="pos" select="position()" />
+
+    <!-- variable -->
+    <xsl:variable name="rowClass">altRow_<xsl:value-of select="position() mod 2"/></xsl:variable>
+     <!-- end of variable -->
+     
+     
+     <div id="{$widgetId}_{$layerId}_Row" class="{$rowClass}" onmouseover="config.objects.{$widgetId}.highlightLayer('{$layerId}')">
+					<!-- div necessary with IE 6 because if not, float makes bugs when display or fold legend -->
+				<div style="position:relative;">
+					<div id="{$widgetId}_{$layerId}_Header " class="LayerHeader">
+			
+						  <!-- layer's index --> 
+						  <div class="indexLayerHeader" title="{$layerIndexTip}">
+								<xsl:value-of select="$numLayers - count(preceding::wmc:Layer) - count(preceding::wmc:FeatureType)"/>
+						  </div>
+						  
+						  <div class="inputLayerHeader">
+            <xsl:choose>
+              <xsl:when test="$mode = 'layerselect'">
+                <!-- add layer -->
+                <a
+                  href="javascript:config.objects.{$widgetId}.copyToTargetModel('{$layerId}')"
+                  class="mbButton"><img title="add this Layer" src="{$skinDir}{$layerAddImage}" />
+                </a>
+              </xsl:when>
+              <xsl:otherwise>
+								<!-- checkbox -->
+								  <div class="checkboxLayerHeader">
+									  <input type="checkbox" id="vis_{$widgetId}_{$layerId}" title="{$toggleVisTip}" onclick="{$context}.setHidden('{$layerId}',!document.getElementById('vis_{$widgetId}_{$layerId}').checked)">
+									      <xsl:if test="@hidden='0' or @hidden='false'"><xsl:attribute name="checked"/></xsl:if>
+									  </input>
+								  </div>
+								  <!-- movelayerup--> 
+								  <xsl:if test="($numLayers - count(preceding::wmc:Layer) - count(preceding::wmc:FeatureType))!=1">  
+										  <div class="buttonLayerHeader">
+										      <a href="javascript:{$context}.setParam('moveLayerUp','{$layerId}')" class="mbButton">
+											      <img title="{$moveLayerUpTip}" src="{$skinDir}{$moveUpImage}" />
+										      </a>
+										  </div>
+								   </xsl:if>
+								   <!-- movelayerdonw -->
+								   <xsl:if test="($numLayers - count(preceding::wmc:Layer) - count(preceding::wmc:FeatureType)) != $numLayers">
+										  <div class="buttonLayerHeader">
+										      <a href="javascript:{$context}.setParam('moveLayerDown','{$layerId}')" class="mbButton">
+											      <img title="{$moveLayerDownTip}" src="{$skinDir}{$moveDownImage}" />
+										      </a>
+										  </div>
+								    </xsl:if>
+								   <!-- deletelayer -->
+								  <div class="buttonLayerHeader">
+								      <a href="javascript:{$context}.setParam('deleteLayer','{$layerId}')" class="mbButton">
+										<img title="{$deleteLayerTip}" src="{$skinDir}{$deleteImage}" />
+									   </a>
+									   </div>
+									 <!-- displayLegend -->   
+								   <xsl:if test="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL"> 
+									   <div class="buttonLayerHeader"  > 
+											<a href="#" 
+											onclick="config.objects.{$widgetId}.switchVisibilityById('{$layerId}_legend');config.objects.{$widgetId}.ChangeImage('image_{$layerId}','{$legendImageEnable}','{$legendImageDisable}');"
+											 class="mbButton">
+											 	
+												    <img id="image_{$layerId}" title="{$legendTip}" >
+														<xsl:attribute name="SRC">
+															<xsl:choose>
+																<xsl:when test="@hidden='1' or @hidden='true'">
+																	<xsl:value-of select="$skinDir"/>
+																	<xsl:value-of select="$legendImageDisable"/>
+																</xsl:when>
+																<xsl:otherwise>
+																	<xsl:value-of select="$skinDir"/>
+																	<xsl:value-of select="$legendImageEnable"/>
+																</xsl:otherwise>
+															</xsl:choose> 
+														</xsl:attribute>
+													</img>
+										   </a>
+									   </div> 
+									 </xsl:if>
+              </xsl:otherwise>
+            </xsl:choose> 
+            <xsl:if test="$layerMetadata">
+                <!-- show layer metadata-->
+                <a
+                  href="javascript:config.objects.{$modelId}.callListeners('layerMetadata', {{layerId: '{$layerId}', domNodeId: '{$widgetId}_{$layerId}_Metadata'}});config.objects.{$widgetId}.ChangeImage('image_{$layerId}','{$layerMetadataImageEnable}','{$layerMetadataImageDisable}');"
+                  class="mbButton"><img id="image_{$layerId}" title="show layer's metadata" src="{$skinDir}{$layerMetadataImageDisable}" />
+                </a>
+            </xsl:if>
+							</div> <!-- end inputLayerHeader --> 	 
+						    <!-- name of layer --> 
+						    <div class="nameLayerHeader" title="{$nameLayerTip}">
+							    <xsl:choose>
+							       <xsl:when test="wmc:Title/@xml:lang">              
+								       <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
+							       </xsl:when>
+							       <xsl:otherwise>
+								       <xsl:value-of select="wmc:Title"/>
+							       </xsl:otherwise>
+							    </xsl:choose>
+						    </div>
+					        <!-- opacity -->  
+					        <xsl:if test="$opacity='true'"> 
+								<div id="transptitle" class="transpLayerHeader" >
+										<form title="{$opacityTip}" >
+											<select name="opacity" onchange="config.objects.{$modelId}.setOpacity('{$layerId}',value)">
+													<xsl:if test="@opacity">
+														<option value="@opacity">
+														<xsl:value-of select="@opacity"/></option>
+													</xsl:if>
+													<option value="1">1</option>
+													<option value="0.8">0.8</option>
+													<option value="0.6">0.6</option>
+													<option value="0.4">0.4</option>
+													<option value="0.2">0.2</option>
+													<option value="0">0</option>
+											</select>
+										</form>
+								 </div>
+					         </xsl:if>
+					</div> <!--end of {$widgetId}_{$layerId}_Header -->	
+
+          <xsl:if test="$layerMetadata">
+          <!-- metadata -->
+          <div id="{$widgetId}_{$layerId}_Metadata"></div>
+          </xsl:if>
+
+          <!-- Loading spinner -->
+          <div id="{$layerId}_Loading" class="layerLoading">
+          <xsl:if test="@isLoading and (@hidden='0' or @hidden='false')">
+            <img title="This layer is being loaded" src="{$skinDir}{$loadingImage}" />
+          </xsl:if>
+          </div>
+
+				</div>	<!--end of hack ie 5.5 -->	
+				<!-- legend -->
+			    <xsl:if test="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL"> 
+			    			
+			    				
+							<div class="legend" id="{$layerId}_legend" >
+								<xsl:attribute name="style">
+									<xsl:choose>
+										<xsl:when test="@hidden='1' or @hidden='true'">display:none </xsl:when>
+										<xsl:otherwise>display:block</xsl:otherwise>
+									</xsl:choose> 
+								</xsl:attribute>
+							    <xsl:element name="IMG"  >
+									<xsl:attribute name="SRC">
+										<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL/wmc:OnlineResource/@xlink:href"/> 
+									</xsl:attribute>
+								</xsl:element>
+							</div>
+				</xsl:if>		 
+    </div> <!--end of "{$widgetId}_{$layerId}_Row" --> 
+</xsl:template>
+<xsl:template match="text()|@*"/>
+</xsl:stylesheet>
